* Mylib.ch
*
* Header file serving NETOPEN.PRG & NETLOCK.PRG
* see Clipper Advisor Jul/Aug '94 & Nov/Dec '94

#define RECORDLOCK      1
#define FILELOCK        2
#define APPENDREC       3

#xcommand DEFAULT <Var1> TO <Val1>;
               [, <Varn> TO <Valn> ]  ;
          =>                                     ;
          IF <Var1> == NIL ; <Var1> := <Val1> ; END ;
       [; IF <Varn> == NIL ; <Varn> := <Valn> ;
       END ]

* From Clipper Advisor July/August '94 p. 44 , but modified:
#command  IF_NETOPEN <(db)>                         ;
    [VIA <rdd>]                                     ;
    [ALIAS <a>]                                     ;
    [<new: NEW>]                                    ;
    [<ex: EXCLUSIVE>]                               ;
    [<sh: SHARED>]                                  ;
    [<ro: READONLY>]                                ;
    [WAIT <wait>]                                   ;
                                                    ;
    => if NetOpen( <(db)>, if(!<.sh.> .or.          ;
                <.ex.>, <.ex.>, NIL),               ;
          <wait>, <(a)>, if(<.new.>,<.new.>,NIL),   ;
          <rdd>, if(<.ro.>,<.ro.>,NIL) )

* From IVDBF.CH:
#command APPEND MEMO <mfld> [ FROM <file> ] [ <ov: OVERWRITE> ] [ BINARY ] ;
                                                                        ;
         =>     _dAppMemo( d4FieldBlock( #<mfld> ), <(file)>, <.ov.> )

#command COPY MEMO <mfld> [ TO <file> ] [ <add: ADDITIVE> ]             ;
                                                                        ;
         =>     _dCopyMemo( <mfld>, <(file)>, <.add.> )

* From Grump.ch:
/* WAITOF() is now a preprocessor function that calls WAITON() with
   a logical as the first parameter, which indicates to WAITON() that
   it must restore the affected portion of the screen...              */
#xcommand waitof( [<sound:ON,NOISE,SOUND>] ) => WaitOn(.F., <.sound.>)

/*
#xcommand Charge => tunes({ {523,2}, {698,2}, {880,2}, {1046,4}, ;
                            {880,2}, {1046,8} } )
#xcommand NannyBoo => tunes( { {196,4}, {196,4}, {164,4}, {220,4}, ;
                               {196,8}, {164,8} } )
#xcommand TheFifth => tunes( { {392,2}, {392,2}, {392,2}, {311,8} } )
#xcommand tunes(<a>) => aeval(<a>, { | a | tone(a\[1], a\[2]) } )
*/