*------------------------------------------------------------------------------
* PPP4fwh.prg                                            Jan 29, 2008
*                                                        R. W. Seiler
*   Protection Plus Professional 4.4.1 DLL Function calls for FWH & xHarbour...
*      (version using LPLONG defined as PTR - see README.TXT)
*   Compile and link with KEYLIB32.DLL & KEYLIB32.LIB & KEYLIB.CH
*   Remember to distribute KEYLIB32.DLL with your app.
*   Suggestion: conserve memory by commenting the functions you're not using.
*
*   Prior 16 bit users of PPP should see note at bottom regarding obsolete funcs.
*------------------------------------------------------------------------------
#include "FiveWin.ch"
#define LPLONG PTR  // Needed because FWH's DLL32 uses PTR instead of LPLONG

// Note that whereas all LPLONG are "return by reference," not all LPSTR are
// "return by reference."

// IMPORTANT: Any buffer value passed by reference must be initialized to 0 
//            or spaces the first time a function is called - i.e. @lfhandle.

// PPP4 Function prototypes follow...
DLL32 Function pp_adddays( @month As LPLONG, @day As LPLONG, @year As LPLONG, days As LONG) As VOID PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_bitclear( @bit_field As LPLONG, bit_number As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_bitset( @bit_field As LPLONG, bit_number As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_bittest( bit_field As LONG, bit_number As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_cenum() As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_checksum( filename As LPSTR, @checksum As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_chkvarchar( handle As LONG, var_no As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_chkvardate( handle As LONG, var_no As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_chkvarnum( handle As LONG, var_no As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_compno( cnotype As LONG, filename As LPSTR, hard_drive As LPSTR) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_compno32drivers( driver As LONG, flags As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_convertv3( handle As LONG, v3_cf As LPSTR, v3_cpf As LPSTR, v3_sn As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_copyadd( handle As LONG, flags As LONG, comp_num As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_copycheck( handle As LONG, action As LONG, comp_num As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_copycheckth( handle As LONG, action As LONG, comp_num As LONG, threshold As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_copydelete( handle As LONG, comp_num As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_copyget( handle As LONG, slot As LONG, @comp_num As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_countdec( handle As LONG, var_no As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_countinc( handle As LONG, var_no As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_daysleft( handle As LONG, @daysleft As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_decrypt( iinstr As LPSTR, pwstr As LPSTR, @ret As LPSTR) As VOID PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_encrypt( iinstr As LPSTR, pwstr As LPSTR, @ret As LPSTR) As VOID PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_errorstr( number As LONG, @buffer As LPSTR) As VOID PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_expired( handle As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_exportactfile( flags As LONG, lfhandle As LONG, @regsavepath As LPSTR, @filepath As LPSTR, @server As LPSTR, @url As LPSTR, @key As LPSTR, licenseid As LONG, @password As LPSTR, compid As LONG, version As LPSTR, productid As LONG, source As LPSTR) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_eztrial1( filename As LPSTR, password As LPSTR, @errorcode As LPLONG, @lfhandle As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_eztrial2( hwnd As LONG, filename As LPSTR, password As LPSTR, flags As LONG, @errorcode As LPLONG, @lfhandle As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_eztrial1test( lfhandle As LONG, @errorcode As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_eztrig1( hwnd As LONG, filename As LPSTR, password As LPSTR, @errorcode As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_eztrig1dlg( hwnd As LONG, handle As LONG, flags As LONG, dlg_labels As LPSTR, usercode1 As LONG, usercode2 As LONG, tcseed As LONG, regkey2seed As LONG, @tcvalue As LPLONG, @tcdata As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_eztrig1ex( handle As LONG, regkey1 As LONG, regkey2 As LONG, flags As LONG, usercode1 As LONG, usercode2 As LONG, tcseed As LONG, regkey2seed As LONG, @tcvalue As LPLONG, @tcdata As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_filedelete( filename As LPSTR) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_getcode( hwnd As LONG, str_title As LPSTR, str_cenum As LPSTR, str_comp As LPSTR, str_code As LPSTR) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_getdate( @month As LPLONG, @day As LPLONG, @year As LPLONG, @dayofweek As LPLONG) As VOID PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_gettime( @hours As LPLONG, @minutes As LPLONG, @seconds As LPLONG, @hseconds As LPLONG) As VOID PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_getvarchar( handle As LONG, var_no As LONG, @buffer As LPSTR) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_getvardate( handle As LONG, var_no As LONG, @month_hours As LPLONG, @day_minutes As LPLONG, @year_seconds As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_getvarnum( handle As LONG, var_no As LONG, @value As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_gotourl( hwnd As LONG, lfhandle As LONG, flags As LONG, url As LPSTR) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_hdserial( drive As LPSTR) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_importactfile( flags As LONG, lfhandle As LONG, filetype As LONG, compid As LONG, @regkey1 As LPLONG, @regkey2 As LPLONG, @session As LPLONG, @licensupd As LPSTR) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_initlib(hInstance As LONG) As VOID PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_lanactive( handle As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_lancheck( handle As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_lastday( month As LONG, @day As LPLONG, year As LONG) As VOID PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_lfalias( handle As LONG, filename As LPSTR, lfflags As LONG, lftype As LONG, password As LPSTR, @recenthandle As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_lfclose( handle As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_lfcopy( handle As LONG, filename As LPSTR, lftype As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_lfcreate( file As LPSTR, flags As LONG, lftype As LONG, password As LPSTR, attrib As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_lfdelete( file As LPSTR, flags As LONG, lftype As LONG, password As LPSTR) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_lflock( mem_handle As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_lfopen( filename As LPSTR, lfflags As LONG, lftype As LONG, password As LPSTR, @handle As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_lfunlock( mem_handle As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_libtest( testnum As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_libversion( @ver1 As LPLONG, @ver2 As LPLONG, @ver3 As LPLONG, @ver4 As LPLONG) As Void PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_ndecrypt( number As LONG, seed As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_ndecryptx( @buffer As LPSTR, @number1 As LPLONG, @number2 As LPLONG, @number3 As LPLONG, @number4 As LPLONG, seed As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_nencrypt( number As LONG, seed As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_nencryptx( @buffer As LPSTR, number1 As LONG, number2 As LONG, number3 As LONG, number4 As LONG, seed As LONG) As VOID PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_netclose( lNetHandle As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_netopen( NetPassword As LPSTR, flags As LONG, time_out As LONG, unused_string As LPSTR, @lNetHandle As LPLONG, @lErrorCode As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_nettest( lNetHandle As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_npdate( @month As LPLONG, @day As LPLONG, @year As LPLONG, dop As LONG) As VOID PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_password( instring As LPSTR) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_redir( drive As LPSTR) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_semclose( handle As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_semcount( handle As LONG, semtype As LONG, prefix_server As LPSTR, name As LPSTR, @number As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_semopen( handle As LONG, semtype As LONG, prefix_server As LPSTR, name As LPSTR, @sem_handle As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_semtest( handle As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_semused( handle As LONG, semtype As LONG, prefix_server As LPSTR, name As LPSTR, @number As LPLONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_setvarchar( handle As LONG, var_no As LONG, buffer As LPSTR) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_setvardate( handle As LONG, var_no As LONG, month_hours As LONG, day_minutes As LONG, year_seconds As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_setvarnum( handle As LONG, var_no As LONG, value As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_sysinfo( flags As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_tcode( number As LONG, cenum As LONG, computer As LONG, seed As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_timercheck( timestamp As LONG, minutes As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_timerstart( ) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_transfer( handle As LONG, filename As LPSTR, password As LPSTR, comp_num As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_upddate( handle As LONG, flag As LONG) As LONG PASCAL LIB "Keylib32.dll" 
DLL32 Function pp_valdate( handle As LONG) As LONG PASCAL LIB "Keylib32.dll" 

// Only comment these in if you are directed to do so
//DLL32 FUNCTION pp_cedate( cenum As LONG, @month As LPLONG, @day As LPLONG, @year As LPLONG) AS VOID PASCAL Lib "TrgLib32.dll" 
//DLL32 Function pp_ctcodes( code As LONG, cenum As LONG, computer As LONG, seed As LONG) As LONG PASCAL Lib "TrgLib32.dll" 


// Other Windows API functions used
*Global Const SW_SHOWNORMAL = 1
DLL32 Function ShellExecute( hwnd As LONG, @lpOperation As LPSTR, @lpFile As LPSTR, @lpParameters As LPSTR, @lpDirectory As LPSTR, nShowCmd As LONG) As LONG PASCAL FROM "ShellExecuteA" Lib "shell32.dll" 
DLL32 Function GetWindowsDirectory( @buffer As LPSTR, length As LONG) As LONG PASCAL FROM "GetWindowsDirectoryA" LIB "Kernel32.dll" 
DLL32 Function GetSystemDirectory( @buffer As LPSTR, length As LONG) As LONG PASCAL FROM "GetSystemDirectoryA" LIB "Kernel32.dll" 

/*
// Other Windows API functions used  [original "Alias" versions...]
*Global Const SW_SHOWNORMAL = 1
DLL32 Function ShellExecute Alias "ShellExecuteA" ( hwnd As LONG, @lpOperation As LPSTR, @lpFile As LPSTR, @lpParameters As LPSTR, @lpDirectory As LPSTR, nShowCmd As LONG) As LONG PASCAL Lib "shell32.dll" 
DLL32 Function GetWindowsDirectory Alias "GetWindowsDirectoryA" ( @buffer As LPSTR, length As LONG) As LONG PASCAL LIB "Kernel32.dll" 
DLL32 Function GetSystemDirectory Alias "GetSystemDirectoryA" ( @buffer As LPSTR, length As LONG) As LONG PASCAL LIB "Kernel32.dll" 
*/

/*
  The following functions from the 16 bit version of 
  Protection Plus Professional are apparently no longer supported by
  SoftwareKey.com ( Concept Software, Inc. ) in the current
  32 bit version of PPP.  See current PPP docs for their replacements.

  pp_advect()
  pp_copywrite( "myfile.drv", 1, nCompno, 0 )
  pp_exelimit()
  pp_expdate(mo,day,yr)
  pp_exptype()
  pp_initcf( pp_path() + "myctl.ppp" )

  // These lan functions are now replaced by new semaphore functions...
  pp_landecr( nAmt )
  pp_lanincr( nAmt )
  pp_lanlimit()
  pp_lanplus( nAmt )
  pp_lanusers()

  pp_nexect( 0 ) 
  pp_nexelim( 5 )
  pp_nexptype() 
  pp_nlanlim( 0 )
  pp_serial( cSerial )
  pp_ucode( get_code, code_no, nCompno)
  pp_writec(cLFname)
*/
