*------------------------------------------------------------------------------
* PPP4xhb.prg - for use with xHarbour without FWH        Apr 3, 2008
*                                                        R. W. Seiler
*
*   To use this file, you must #INCLUDE "DLLxHb.ch" in your program.
*
*   Protection Plus Professional 4.4.1 DLL Function calls for xHarbour...
*   Compile and link with KEYLIB32.LIB & KEYLIB.CH, with KEYLIB32.LIB in app dir.
*   Remember to distribute KEYLIB32.DLL with your app.
*
*   Prior 16 bit users of PPP should see note at bottom regarding obsolete funcs.
*------------------------------------------------------------------------------
#include "DLLxHb.ch"
#include "wintypes.ch"
#include "Keylib.ch"

// Note that whereas all LPLONG are "return by reference," not all LPSTR are
// "return by reference."

// IMPORTANT: Any buffer value passed by reference must be initialized to 0 
//            or spaces the first time a function is called - i.e. @lfhandle.

// PPP4 Function prototypes follow...
DLLxHb Function pp_adddays( @month, @day, @year, days) LIB "Keylib32.dll" 
DLLxHb Function pp_bitclear( @bit_field, bit_number) LIB "Keylib32.dll" 
DLLxHb Function pp_bitset( @bit_field, bit_number) LIB "Keylib32.dll" 
DLLxHb Function pp_bittest( bit_field, bit_number) LIB "Keylib32.dll" 
DLLxHb Function pp_cenum() LIB "Keylib32.dll" 
DLLxHb Function pp_checksum( filename, @checksum) LIB "Keylib32.dll" 
DLLxHb Function pp_chkvarchar( handle, var_no) LIB "Keylib32.dll" 
DLLxHb Function pp_chkvardate( handle, var_no) LIB "Keylib32.dll" 
DLLxHb Function pp_chkvarnum( handle, var_no) LIB "Keylib32.dll" 
DLLxHb Function pp_compno( cnotype, filename, hard_drive) LIB "Keylib32.dll" 
DLLxHb Function pp_compno32drivers( driver, flags) LIB "Keylib32.dll" 
DLLxHb Function pp_convertv3( handle, v3_cf, v3_cpf, v3_sn) LIB "Keylib32.dll" 
DLLxHb Function pp_copyadd( handle, flags, comp_num) LIB "Keylib32.dll" 
DLLxHb Function pp_copycheck( handle, action, comp_num) LIB "Keylib32.dll" 
DLLxHb Function pp_copycheckth( handle, action, comp_num, threshold) LIB "Keylib32.dll" 
DLLxHb Function pp_copydelete( handle, comp_num) LIB "Keylib32.dll" 
DLLxHb Function pp_copyget( handle, slot, @comp_num) LIB "Keylib32.dll" 
DLLxHb Function pp_countdec( handle, var_no) LIB "Keylib32.dll" 
DLLxHb Function pp_countinc( handle, var_no) LIB "Keylib32.dll" 
DLLxHb Function pp_daysleft( handle, @daysleft) LIB "Keylib32.dll" 
DLLxHb Function pp_decrypt( iinstr, pwstr, @ret) LIB "Keylib32.dll" 
DLLxHb Function pp_encrypt( iinstr, pwstr, @ret) LIB "Keylib32.dll" 
DLLxHb Function pp_errorstr( number, @buffer) LIB "Keylib32.dll" 
DLLxHb Function pp_expired( handle) LIB "Keylib32.dll" 
DLLxHb Function pp_exportactfile( flags, lfhandle, @regsavepath, @filepath, @server, @url, @key, licenseid, @password, compid, version, productid, source) LIB "Keylib32.dll" 
DLLxHb Function pp_eztrial1( filename, password, @errorcode, @lfhandle) LIB "Keylib32.dll" 
DLLxHb Function pp_eztrial2( hwnd, filename, password, flags, @errorcode, @lfhandle) LIB "Keylib32.dll" 
DLLxHb Function pp_eztrial1test( lfhandle, @errorcode) LIB "Keylib32.dll" 
DLLxHb Function pp_eztrig1( hwnd, filename, password, @errorcode) LIB "Keylib32.dll" 
DLLxHb Function pp_eztrig1dlg( hwnd, handle, flags, dlg_labels, usercode1, usercode2, tcseed, regkey2seed, @tcvalue, @tcdata) LIB "Keylib32.dll" 
DLLxHb Function pp_eztrig1ex( handle, regkey1, regkey2, flags, usercode1, usercode2, tcseed, regkey2seed, @tcvalue, @tcdata) LIB "Keylib32.dll" 
DLLxHb Function pp_filedelete( filename) LIB "Keylib32.dll" 
DLLxHb Function pp_getcode( hwnd, str_title, str_cenum, str_comp, str_code) LIB "Keylib32.dll" 
DLLxHb Function pp_getdate( @month, @day, @year, @dayofweek) LIB "Keylib32.dll" 
DLLxHb Function pp_gettime( @hours, @minutes, @seconds, @hseconds) LIB "Keylib32.dll" 
DLLxHb Function pp_getvarchar( handle, var_no, @buffer) LIB "Keylib32.dll" 
DLLxHb Function pp_getvardate( handle, var_no, @month_hours, @day_minutes, @year_seconds) LIB "Keylib32.dll" 
DLLxHb Function pp_getvarnum( handle, var_no, @value) LIB "Keylib32.dll" 
DLLxHb Function pp_gotourl( hwnd, lfhandle, flags, url) LIB "Keylib32.dll" 
DLLxHb Function pp_hdserial( drive) LIB "Keylib32.dll" 
DLLxHb Function pp_importactfile( flags, lfhandle, filetype, compid, @regkey1, @regkey2, @session, @licensupd) LIB "Keylib32.dll" 
DLLxHb Function pp_initlib(hInstance) LIB "Keylib32.dll" 
DLLxHb Function pp_lanactive( handle) LIB "Keylib32.dll" 
DLLxHb Function pp_lancheck( handle) LIB "Keylib32.dll" 
DLLxHb Function pp_lastday( month, @day, year) LIB "Keylib32.dll" 
DLLxHb Function pp_lfalias( handle, filename, lfflags, lftype, password, @recenthandle) LIB "Keylib32.dll" 
DLLxHb Function pp_lfclose( handle) LIB "Keylib32.dll" 
DLLxHb Function pp_lfcopy( handle, filename, lftype) LIB "Keylib32.dll" 
DLLxHb Function pp_lfcreate( file, flags, lftype, password, attrib) LIB "Keylib32.dll" 
DLLxHb Function pp_lfdelete( file, flags, lftype, password) LIB "Keylib32.dll" 
DLLxHb Function pp_lflock( mem_handle) LIB "Keylib32.dll" 
DLLxHb Function pp_lfopen( filename, lfflags, lftype, password, @handle) LIB "Keylib32.dll" 
DLLxHb Function pp_lfunlock( mem_handle) LIB "Keylib32.dll" 
DLLxHb Function pp_libtest( testnum) LIB "Keylib32.dll" 
DLLxHb Function pp_libversion( @ver1, @ver2, @ver3, @ver4) LIB "Keylib32.dll" 
DLLxHb Function pp_ndecrypt( number, seed) LIB "Keylib32.dll" 
DLLxHb Function pp_ndecryptx( @buffer, @number1, @number2, @number3, @number4, seed) LIB "Keylib32.dll" 
DLLxHb Function pp_nencrypt( number, seed) LIB "Keylib32.dll" 
DLLxHb Function pp_nencryptx( @buffer, number1, number2, number3, number4, seed) LIB "Keylib32.dll" 
DLLxHb Function pp_netclose( lNetHandle) LIB "Keylib32.dll" 
DLLxHb Function pp_netopen( NetPassword, flags, time_out, unused_string, @lNetHandle, @lErrorCode) LIB "Keylib32.dll" 
DLLxHb Function pp_nettest( lNetHandle) LIB "Keylib32.dll" 
DLLxHb Function pp_npdate( @month, @day, @year, dop) LIB "Keylib32.dll" 
DLLxHb Function pp_password( instring) LIB "Keylib32.dll" 
DLLxHb Function pp_redir( drive) LIB "Keylib32.dll" 
DLLxHb Function pp_semclose( handle) LIB "Keylib32.dll" 
DLLxHb Function pp_semcount( handle, semtype, prefix_server, name, @number) LIB "Keylib32.dll" 
DLLxHb Function pp_semopen( handle, semtype, prefix_server, name, @sem_handle) LIB "Keylib32.dll" 
DLLxHb Function pp_semtest( handle) LIB "Keylib32.dll" 
DLLxHb Function pp_semused( handle, semtype, prefix_server, name, @number) LIB "Keylib32.dll" 
DLLxHb Function pp_setvarchar( handle, var_no, buffer) LIB "Keylib32.dll" 
DLLxHb Function pp_setvardate( handle, var_no, month_hours, day_minutes, year_seconds) LIB "Keylib32.dll" 
DLLxHb Function pp_setvarnum( handle, var_no, value) LIB "Keylib32.dll" 
DLLxHb Function pp_sysinfo( flags) LIB "Keylib32.dll" 
DLLxHb Function pp_tcode( number, cenum, computer, seed) LIB "Keylib32.dll" 
DLLxHb Function pp_timercheck( timestamp, minutes) LIB "Keylib32.dll" 
DLLxHb Function pp_timerstart( ) LIB "Keylib32.dll" 
DLLxHb Function pp_transfer( handle, filename, password, comp_num) LIB "Keylib32.dll" 
DLLxHb Function pp_upddate( handle, flag) LIB "Keylib32.dll" 
DLLxHb Function pp_valdate( handle) LIB "Keylib32.dll" 

// Only comment these in if you are directed to do so
//DLLxHb FUNCTION pp_cedate( cenum, @month, @day, @year) Lib "TrgLib32.dll" 
//DLLxHb Function pp_ctcodes( code, cenum, computer, seed) Lib "TrgLib32.dll" 


// Other Windows API functions used
**Global Const SW_SHOWNORMAL = 1
*DLLxHb Function ShellExecute( hwnd, @lpOperation, @lpFile, @lpParameters, @lpDirectory, nShowCmd) FROM "ShellExecuteA" Lib "shell32.dll" 
*DLLxHb Function GetWindowsDirectory( @buffer, length) FROM "GetWindowsDirectoryA" LIB "Kernel32.dll" 
*DLLxHb Function GetSystemDirectory( @buffer, length) FROM "GetSystemDirectoryA" LIB "Kernel32.dll" 

/*
// Other Windows API functions used  [original "Alias" versions...]
*Global Const SW_SHOWNORMAL = 1
DLLxHb Function ShellExecute Alias "ShellExecuteA" ( hwnd, @lpOperation, @lpFile, @lpParameters, @lpDirectory, nShowCmd) Lib "shell32.dll" 
DLLxHb Function GetWindowsDirectory Alias "GetWindowsDirectoryA" ( @buffer, length) LIB "Kernel32.dll" 
DLLxHb Function GetSystemDirectory Alias "GetSystemDirectoryA" ( @buffer, length) LIB "Kernel32.dll" 
*/

/*
  The following functions from the 16 bit version of 
  Protection Plus Professional are apparently no longer supported by
  SoftwareKey.com ( Concept Software, Inc. ) in the current
  32 bit version of PPP.  See current PPP docs for their replacements.

  pp_advect()
  pp_copywrite( "myfile.drv", 1, nCompno, 0 )
  pp_exelimit()
  pp_expdate(mo,day,yr)
  pp_exptype()
  pp_initcf( pp_path() + "myctl.ppp" )

  // These lan functions are now replaced by new semaphore functions...
  pp_landecr( nAmt )
  pp_lanincr( nAmt )
  pp_lanlimit()
  pp_lanplus( nAmt )
  pp_lanusers()

  pp_nexect( 0 ) 
  pp_nexelim( 5 )
  pp_nexptype() 
  pp_nlanlim( 0 )
  pp_serial( cSerial )
  pp_ucode( get_code, code_no, nCompno)
  pp_writec(cLFname)
*/
